hdu1005Number Sequence

思路:对于公式 f[n] = A * f[n-1] + B * f[n-2]; 后者只有7 * 7 = 49 种可能,为什么这么说,因为对于f[n-1] 或者 f[n-2] 的取值只有 0,1,2,3,4,5,6 这7个数,A,B又是固定的,所以就只有49种可能值了。由该关系式得知每一项只与前两项发生关系,所以当连续的两项在前面出现过循环节出现了,注意循环节并不一定会是开始的 1,1 。 又因为一组测试数据中f[n]只有49中可能的答案,最坏的情况是所有的情况都遇到了,那么那也会在50次运算中产生循环节。找到循环节后,就可以轻松解决了。

#include <iostream>
#include<cstdio>
#include<cstring>
#define maxn 60
using namespace std;

int main()
{
    int a,b,n;
    int f[maxn];
    f[1] = f[2] = 1;
    while(cin >> a >> b >> n && (a!=0||b!=0||n!=0)){
        a %= 7;
        b %= 7;
        //cout << f[1] << endl << f[2] << endl;
        for(int i = 3;i <= 55;i ++){
            //f[i%10] = (f*f[(i-1)%10] + b*f[(i-2)%10])%7;
            f[i] = (a*f[(i-1)] + b*f[(i-2)])%7;
            //cout << f[i] << endl;
        }
        int len = 0;
        int beg, end, flag = 0;
        /*
        for(int i = 3;i <= 55;i ++){
            if(f[i] == f[1] && f[i+1] == f[2]&& f[i+2] == f[3]&& f[i+3] == f[4]&& f[i+4] == f[5]&& f[i+5] == f[6]&& f[i+6] == f[7]){
                len = i-1;
                //cout << "len = " << len << endl;
                break;
            }
        }
        if(len == 0){
            if(n > 2)
                cout << 0 << endl;
            else
                cout << 1 << endl;
        }
        else{
            cout << f[((n-1)%len)+1] << endl;
        }
        */
        for( int i = 3; i <= n && !flag; ++i )
        {
            f[i] = ( a * f[i-1] + b * f[i-2] ) % 7;
            for( int j = 2; j <= i - 1; ++j )
            {
                if( f[i] == f[j] && f[i-1] == f[j-1] )
                {
                    beg = j, end = i;
                    flag = 1;
                    break;
                }
            }
        }
        if( flag )
        {
            printf( "%d\n", f[beg+(n-end)%(end-beg)] );
        }
        else
            printf( "%d\n", f[n] );
    }
    return 0;
}
时间: 2024-11-01 22:22:08

hdu1005Number Sequence的相关文章

HDU-1005-Number Sequence(Java版+考虑周期+恶心水题!)

Number Sequence Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 122527    Accepted Submission(s): 29758 Problem Description A number sequence is defined as follows: f(1) = 1, f(2) = 1, f(n) = (

LeetCode OJ - Longest Consecutive Sequence

这道题中要求时间复杂度为O(n),首先我们可以知道的是,如果先对数组排序再计算其最长连续序列的时间复杂度是O(nlogn),所以不能用排序的方法.我一开始想是不是应该用动态规划来解,发现其并不符合动态规划的特征.最后采用类似于LRU_Cache中出现的数据结构(集快速查询和顺序遍历两大优点于一身)来解决问题.具体来说其数据结构是HashMap<Integer,LNode>,key是数组中的元素,所有连续的元素可以通过LNode的next指针相连起来. 总体思路是,顺序遍历输入的数组元素,对每个

1005 Number Sequence

Problem Description A number sequence is defined as follows: f(1) = 1, f(2) = 1, f(n) = (A * f(n - 1) + B * f(n - 2)) mod 7. Given A, B, and n, you are to calculate the value of f(n). Input The input consists of multiple test cases. Each test case co

HDU 5783 Divide the Sequence(数列划分)

HDU 5783 Divide the Sequence(数列划分) Time Limit: 5000/2500 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)   Problem Description - 题目描述 Alice has a sequence A, She wants to split A into as much as possible continuous subsequences, satisfy

HDU 3397 Sequence operation(线段树)

HDU 3397 Sequence operation 题目链接 题意:给定一个01序列,有5种操作 0 a b [a.b]区间置为0 1 a b [a,b]区间置为1 2 a b [a,b]区间0变成1,1变成0 3 a b 查询[a,b]区间1的个数 4 a b 查询[a,b]区间连续1最长的长度 思路:线段树线段合并.须要两个延迟标记一个置为01,一个翻转,然后因为4操作,须要记录左边最长0.1.右边最长0.1,区间最长0.1,然后区间合并去搞就可以 代码: #include <cstdi

HDU 3998 Sequence (最长递增子序列+最大流SAP,拆点法)经典

Sequence Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1666    Accepted Submission(s): 614 Problem Description There is a sequence X (i.e. x[1], x[2], ..., x[n]). We define increasing subsequ

HDOJ 5147 Sequence II 树状数组

树状数组: 维护每一个数前面比它小的数的个数,和这个数后面比他大的数的个数 再枚举每个位置组合一下 Sequence II Time Limit: 5000/2500 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 121    Accepted Submission(s): 58 Problem Description Long long ago, there is a seq

Acdream 1427 Nice Sequence

Nice Sequence Time Limit: 12000/6000MS (Java/Others)Memory Limit: 128000/64000KB (Java/Others) Problem Description Let us consider the sequence a1, a2,..., an of non-negative integer numbers. Denote as ci,j the number of occurrences of the number i a

hdu5014 Number Sequence(异或运算)

题目链接: huangjing 题意: 这个题目的意思是给出0~n的排列,然后找出与这个序列的配对使(a0 ⊕ b0) + (a1 ⊕ b1) +·+ (an ⊕ bn)最大.. 思路: 从大到小遍历每个数,然后找到与这个数二进制位数互补的数,那么他们的抑或值必定是pow(2,n)-1,,肯定是最大的.... 题目: Number Sequence Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/65536 K (Jav